// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITATTROPTIONS_H
#define GITATTROPTIONS_H
#include <nan.h>
#include <string>
#include <utility>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"
#include "worker_pool.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/oid.h"

using namespace node;
using namespace v8;

class GitAttrOptions;
 
struct GitAttrOptionsTraits {
  typedef GitAttrOptions cppClass;
  typedef git_attr_options cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_attr_options **dest, git_attr_options *src) {
     Nan::ThrowError("duplicate called on GitAttrOptions which cannot be duplicated");
   }

  static std::string className() { return "GitAttrOptions"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_attr_options *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitAttrOptions : public
  NodeGitWrapper<GitAttrOptionsTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitAttrOptionsTraits>;
   public:
    GitAttrOptions(const GitAttrOptions &) = delete;
    GitAttrOptions(GitAttrOptions &&) = delete;
    GitAttrOptions &operator=(const GitAttrOptions &) = delete;
    GitAttrOptions &operator=(GitAttrOptions &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitAttrOptions()
      : NodeGitWrapper<GitAttrOptionsTraits>(
           "A new GitAttrOptions cannot be instantiated."
       )
    {}
    GitAttrOptions(git_attr_options *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitAttrOptionsTraits>(raw, selfFreeing, owner)
    {}
    ~GitAttrOptions();
    static NAN_METHOD(Version);
    static NAN_METHOD(Flags);
    static NAN_METHOD(CommitId);
    static NAN_METHOD(AttrCommitId);
};

#endif
