// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITCOMMITGRAPH_H
#define GITCOMMITGRAPH_H
#include <nan.h>
#include <string>
#include <utility>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"
#include "worker_pool.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

// Forward declaration.
struct git_commit_graph {
};

using namespace node;
using namespace v8;

class GitCommitGraph;
 
struct GitCommitGraphTraits {
  typedef GitCommitGraph cppClass;
  typedef git_commit_graph cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_commit_graph **dest, git_commit_graph *src) {
     Nan::ThrowError("duplicate called on GitCommitGraph which cannot be duplicated");
   }

  static std::string className() { return "GitCommitGraph"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_commit_graph *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitCommitGraph : public
  NodeGitWrapper<GitCommitGraphTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitCommitGraphTraits>;
   public:
    GitCommitGraph(const GitCommitGraph &) = delete;
    GitCommitGraph(GitCommitGraph &&) = delete;
    GitCommitGraph &operator=(const GitCommitGraph &) = delete;
    GitCommitGraph &operator=(GitCommitGraph &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitCommitGraph()
      : NodeGitWrapper<GitCommitGraphTraits>(
           "A new GitCommitGraph cannot be instantiated."
       )
    {}
    GitCommitGraph(git_commit_graph *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitCommitGraphTraits>(raw, selfFreeing, owner)
    {}
    ~GitCommitGraph();
};

#endif
