// This is a generated file, modify: generate/templates/templates/class_header.h

#ifndef GITFILTEROPTIONS_H
#define GITFILTEROPTIONS_H
#include <nan.h>
#include <string>
#include <utility>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <sstream>

#include "async_baton.h"
#include "async_worker.h"
#include "cleanup_handle.h"
#include "context.h"
#include "lock_master.h"
#include "nodegit_wrapper.h"
#include "promise_completion.h"
#include "reference_counter.h"
#include "worker_pool.h"

extern "C" {
#include <git2.h>
}

#include "../include/typedefs.h"

#include "../include/oid.h"

using namespace node;
using namespace v8;

class GitFilterOptions;
 
struct GitFilterOptionsTraits {
  typedef GitFilterOptions cppClass;
  typedef git_filter_options cType;
 
  static const bool isDuplicable = false;
  static void duplicate(git_filter_options **dest, git_filter_options *src) {
     Nan::ThrowError("duplicate called on GitFilterOptions which cannot be duplicated");
   }

  static std::string className() { return "GitFilterOptions"; };
  static const bool isSingleton = false;
  static const bool isFreeable = true;
  static void free(git_filter_options *raw) {
    unsigned long referenceCount = 0;
     if (referenceCount == 0) {
      ::free(raw); // :: to avoid calling this free recursively
    }
   }
};

class GitFilterOptions : public
  NodeGitWrapper<GitFilterOptionsTraits>
{
    // grant full access to base class
    friend class NodeGitWrapper<GitFilterOptionsTraits>;
   public:
    GitFilterOptions(const GitFilterOptions &) = delete;
    GitFilterOptions(GitFilterOptions &&) = delete;
    GitFilterOptions &operator=(const GitFilterOptions &) = delete;
    GitFilterOptions &operator=(GitFilterOptions &&) = delete;

    static void InitializeComponent (v8::Local<v8::Object> target, nodegit::Context *nodegitContext);

 

  private:
    GitFilterOptions()
      : NodeGitWrapper<GitFilterOptionsTraits>(
           "A new GitFilterOptions cannot be instantiated."
       )
    {}
    GitFilterOptions(git_filter_options *raw, bool selfFreeing, v8::Local<v8::Object> owner = v8::Local<v8::Object>())
      : NodeGitWrapper<GitFilterOptionsTraits>(raw, selfFreeing, owner)
    {}
    ~GitFilterOptions();
    static NAN_METHOD(Version);
    static NAN_METHOD(Flags);
    static NAN_METHOD(CommitId);
    static NAN_METHOD(AttrCommitId);
};

#endif
